# Getting started with A-Core Chisel development

This guide attempts to explain the basic development workflow related to A-Core Chisel implementation. While this guide aims to be as thorough as possible, it is likely that there are some errors. If you encounter any problems while following the tutorial please open an issue or send a message to the `chisel-dev-guide` channel in the A-Core slack group.

This guide is divided into three sections:
* Section 1 will guide you through the initial setup
* Section 2 will describe how to elaborate the A-Core Chisel implementation to verilog, and
* Section 3 and 4 will guide you through creating a new hardware module and integrating it with the existing codebase using good git practices.

**Authors:**
* Verneri Hirvonen, [verneri.hirvonen@aalto.fi](mailto://verneri.hirvonen@aalto.fi)



## 1. Initial setup
These steps will familiarize you with the command line interface and by the end of this section you should have a copy of the A-Core source files in your working machine.

### 1.1. Connect to the department computers
All development should be done with the department's computers. Use x2go or you favourite ssh client to connect to one of the computers before continuing.

### 1.2. Familiarize yourself with the terminal
If you are not familiar with UNIX-style command line interfaces you should learn the basics before proceeding to the following sections. You should at least be able to carry out basic tasks such as navigating the file system, listing files in the current directory, and running shell scripts. To get you started, you can use e.g. [this tutorial](https://web.archive.org/web/20210913234830/https://scicomp.aalto.fi/training/linux-shell-tutorial/) as a starting point.

### 1.3. Initial git configuration
Before you can create git commits, you need to tell git your name and email address so that it can associate each commit with this information. This can be achieved by typing the following commands into the terminal. Any text inside angle brackets `<like-this-text-here>` is meant to be replaced by appropriate information. The dollar sign symbol `$` is the shell prompt and should be left out when typing these commands to the terminal.

```shell
$ git config --global user.name '<your-name>'
$ git config --global user.email '<your-email>'
```

For example, if your name were Teemu Teekkari you could type the following commands:
```shell
$ git config --global user.name 'Teemu Teekkari'
$ git config --global user.email 'teemu.teekkari@aalto.fi'
```

### 1.4. Clone relevant git repositories.
* `chisel-blocks-utils` -- Contains helper scripts for generating new hardware modules
* `ACoreChip` -- Contains the A-Core implementation written in Chisel.

Navigate to your A-Core project directory: On the department machines this should be located at `/home/pro/a-core/<your-username>`. The following commands will clone, i.e. download copies, of these two repositories from the git server into the machine you are working on.
```shell
$ git clone https://github.com/Chisel-blocks/chisel-blocks-utils.git
$ git clone git@gitlab.com:a-core/a-core_chisel/ACoreChip.git
```

At this point you should have `chisel-blocks-utils` and `ACoreChip` directories present in your current directory (confirm with `ls`).



## 2. Building A-Core
Navigate to the `ACoreChip` directory.

```shell
$ cd ACoreChip
```

### 2.1. Configure project
First, the build system configuration files need to be generated by running

```shell
$ ./configure
```

This will generate a Makefile which is later used by the `make` command to build the core.

### 2.2. Clone and build project submodules

The core implementation has been organized to be modular using git [submodules], which need to be fetched before you can build the project. Instead of using the typical git commands for cloning submodules, this project uses the `init_submodules.sh` shell script to selectively clone only the submodules listed in the script. Now, you can clone by running the following command which will take a while to execute:

```shell
$ ./init_submodules.sh
```

The `init_submodules.sh` script will first clone all submodules not already present, and then proceeds to build the Chisel hardware modules present in the git submodules. This step is crucial because it makes the Chisel hardware modules in the git submodules available to other Chisel code by publishing them to a local scala package repository (apache ivy). Consequently, it is also necessary to run `./init_submodules.sh` any time after updating the project submodules to make the latest changes available for your top-level Chisel generator.

[submodules]: https://git-scm.com/book/en/v2/Git-Tools-Submodules

### 2.3. Building A-Core
Finally, you can build A-Core itself by simply running:
```shell
$ make
```
If the command output complains something about "no specificied targets" or "missing makefile", you have probably forgot to run the `./configure` command. After the build process has been completed, the produced verilog hardware description can be found from the newly created `verilog/` directory in the file `ACoreChip.v`. You can now ispect the core hardware description using your favorite text editor if you wish. For example, `vim verilog/ACoreChip.v` opens the file in the `vim` editor.



## 3. Creating a new hardware module

In most cases when you want to add new features to the core it's enough to create new files to an existing repository, or to modify existing files.
However, sometimes when you're writing a module that could be reused in other contexts, it's a good practice to extract that module to a dedicated repository to facilitate reuse. This is most common at the chip-level hardware description when adding hardware modules around the A-Core processor core.

### 3.1. Creating a repository in GitLab
The first step is to create a new git repository under the A-Core_Chisel group in GitLab. This repository will contain the implementation of your hardware module and it can be used as a submodule by other hardware modules.

1. Navigate to the [A-Core_Chisel] GitLab group with your browser.
2. Click the "New Project" button to start creating a new repository.
![1_new_project](images/1_new_project.png)
3. Give a name to the repository. This should match the name of the Chisel module you are going to create. For consistency, rename also the Project Slug to follow CamelCase. All of the existing repositories and modules follow this naming convention.
![2_project_naming](images/2_project_naming.png)
Congratulations, you have created an empty repository to GitLab. You can ignore the instructions given in the repository page, as we will be using a script from the `chisel-blocks-utils` repository to generate a new project and initialize the contents of the repository.

At this point you have created an empty repository under the `a-core_chisel` group in GitLab. I.e. the repository only exists at the remote side and it doesn't yet have any content.

### 3.2. Creating a new harware module using chisel-blocks-utils
The next step is to create a repository on your working machine, generate a minimal Chisel module as a starting point, and associate the local repository with the remote repository. This process has been automated with a script found in the `chisel-blocks-utils` repository cloned earlier. The script can be used with thte following steps:

1. Navigate to the `chisel-blocks-utils` directory you cloned during the initial git configuration. It should be located at `/home/pro/a-core/<your-username>/chisel-blocks-utils/` if you have completed the initial setup.
2. Determine the address of the newly created repository used for cloning. This can be conveniently done by clicking the _clone_ button in the repository web page and clicking the _copy to clipboard_ button under the "Clone with SSH" section.
![3_clone_addr_1](images/3_clone_addr_1.png)
![3_clone_addr_2](images/3_clone_addr_2.png)
3. The `shell` directory contains the initialization script. You can use it with the `-m` option to specify the name of the new module (the same as your project name in CamelCase), and with the `-R` option to specify the git remote (inside double quotes). You should paste the git clone address obtained during the previous as the value for the remote flag.

In general, you can initialize a hardware-module with the desired characteristics wiht the following command invocation:
```shell
$ shell/init_module.sh -m <YourModuleNameHere> -R <git-clone-address>
```

As a concrete example, the `TutorialHardwareModule` would be initialized with the following invocation:
```shell
$ shell/init_modules.sh -m TutorialHardwareModule -R "git@gitlab.com:a-core/a-core_chisel/TutorialHardwareModule.git"
```

This will create a new git repository on your working machine contained in the directory `<YourModuleNameHere>`. I.e. the concrete example would create a git repository in the directory called `TutorialHardwareModule`. The following discussion will default to using the concrete name, but you should still use the name you have chosen for your module.

At this point you should verify that the hardware module builds without errors:
```shell
$ cd TutorialHardwareModule
$ ./configure && make
```

and that the `origin` remote correctly points to the address determined using the previous step. The lines that don't begin with the `$` symbol are command outputs, and should not be typed to the terminal.
```shell
$ git remote -v
origin	git@gitlab.com:a-core/a-core_chisel/TutorialHardwareModule.git (fetch)
origin	git@gitlab.com:a-core/a-core_chisel/TutorialHardwareModule.git (push)
```

### 3.3. Pushing your local changes to the remote repository

If the origin remote has been configured correctly, you can upload the local files to the remote with
```shell
$ git push --set-upstream origin master
```

This command uploads the files from your local repository to the remote repository in GitLab, and starts tracking changes to the remote repository.

After this step the repository on the git server has the generated project files. You can confirm this by refreshing the GitLab page of your new repository:
![4-remote-with-files](images/4-remote-with-files.png)

### 3.4. Working with git

Git is a collabration tool that makes it possible for multiple people to work on the same codebase at the same time. If you haven't used git before, this is a good time for learning the basics. You will need to know how to use git to work on the project! If your code/designs haven't been pushed to the remote repository, others can't see them so they might as well not exist.

The free online ebook [Pro Git] is a great resource for learning why git is used in the first place, and how the various commands work. It's a good idea to bookmark it for future reference. The most crucial material can be found in chapters 1-3. Learning this material will save you lots of time and headaches in the future.

[Pro Git]: https://git-scm.com/book/en/v2



## 4. Adding a new submodule into ACoreChip

This section will guide you through the workflow of adding your new component into ACoreChip using good open-source collaboration practices.

The project implementation exists in the `master` branch of the repository. The master branch should be a stable and working version of the code. Changes to the codebase should be developed in separate branches which are merged to master to add in the changes. I.e. to change the code in the master branch, you should first create a new branch from master, develop your changes in the new branch, and when the changes have been tested. In practice, branches are merged to master using Pull Requests (PRs) in the GitLab web interface to allow for other to review the proposed changes.

### 4.1. Creating a new branch for your changes

Let's say you want to make changes to `ACoreChip` to add in your new hardware module.

First of all, make sure that you have set the cloned `ACoreChip` repository as your current working directory (confirm with `pwd`). Since the implementation in the remote repository might have changed since the time when you first cloned the repository (remember that there are multiple people working on this project), you should always see if there are new changes available.

```shell
$ git checkout master   # change current branch to master
$ git pull              # download new changes from origin (git server)
```

Your local repository should now match the latest changes in origin/master. You can now branch off master and switch git to track the latest branch. This will cause git to add any new commits to the newly created branch.

```shell
$ git branch <new-branch-name>      # create a new branch
$ git checkout <new-branch-name>    # switch to the newly created branch
```

Alternatively, you can use the command

```shell
$ git checkout -b <new-branch-name>
```

to accomplish these two steps using only a single command.

You can use `git branch` to check what is the currently active branch. The active branch is highlighted in green and has an asterix (`*`) next to its name. Verify that the newly created branch is the active branch before proceeding. 

### 4.2. Adding a hardware submodule

To add a new submodule you can use the following command:
```shell
$ git submodule add git@gitlab.com:a-core/a-core_chisel/TutorialHardwareModule.git
```

You also need to add the name of the submodule to the `SUBMODULES` list in `init_submodules.sh`:
```shell
SUBMODULES="\
    ACoreBase \
    ProgMem \
    JTAG \
    amba \
    TutorialHardwareModule \  # insert this line
    "
```

You can now run the `init_submodules.sh` script to compile and publish `TutorialHardwareModule` to the local scala package repository, which makes it available to the `ACoreChip` module.

Finally, add the following line to `build.sbt` to add the recently built scala package containing the hardware module as a dependency for `ACoreChip` (note that the scala package name is completely lowercase)):
```scala
libraryDependencies += "Chisel-blocks" %% "tutorialhardwaremodule" % gitSubmoduleHashSnapshotVersion("TutorialHardwareModule")
```

Now the build system has been set up to be aware of the new hardware module in a way that it can be used in the `ACoreChip` Chisel implementation.

#### 4.2.1 Note about Chisel dependency control

The project configuration uses git commit hashes for module version numbering. This mechanism allows us to recursively define Chisel hardware dependencies using git submodules.

* Hardware module versioning:
  * The scala build tool config file `build.sbt` of each hardware submodule is configured to use the hash of the currently checked out commit as its verison number. In practice, when running `sbt publishLocal` -- either manually or indirectly through `init_subomdules.sh` -- we are building a scala package with a version in the format `<commit-hash>-SNAPSHOT` (e.g. `2f758b2-SNAPSHOT`), and storing it in the local ivy package database.

* Configuring package dependencies for scala imports
  * To import the scala modules containing Chisel modules defined in submodules, we need to specify where to look for dependencies.
  * This is achieved through the `libraryDependencies` directives at the end of the module's `build.sbt` configuration file.

**Common Problem:** A common problem with this method occurs when you update a dependency defined in a submodule, and forget to build and publish it to the local ivy package repository. In this case, the module using the dependency will look up the version string of the submodule, but fails to find it from the local package repository. The resulting message is a bit confusing as complains about downloading something. An example error output of this scenario is shown below.

<details>
  <summary>Example error message</summary>

```
[error] sbt.librarymanagement.ResolveException: Error downloading Chisel-blocks:amba_2.13:+880734-SNAPSHOT
[error]   Not found
[error]   Not found
[error]   not found: /home/pt/vhirvone/.ivy2/local/Chisel-blocks/amba_2.13/+880734-SNAPSHOT/ivys/ivy.xml
[error]   not found: https://repo1.maven.org/maven2/Chisel-blocks/amba_2.13/+880734-SNAPSHOT/amba_2.13-+880734-SNAPSHOT.pom
[error]         at lmcoursier.CoursierDependencyResolution.unresolvedWarningOrThrow(CoursierDependencyResolution.scala:249)
[error]         at lmcoursier.CoursierDependencyResolution.$anonfun$update$35(CoursierDependencyResolution.scala:218)
[error]         at scala.util.Either$LeftProjection.map(Either.scala:573)
[error]         at lmcoursier.CoursierDependencyResolution.update(CoursierDependencyResolution.scala:218)
[error]         at sbt.librarymanagement.DependencyResolution.update(DependencyResolution.scala:60)
[error]         at sbt.internal.LibraryManagement$.resolve$1(LibraryManagement.scala:52)
[error]         at sbt.internal.LibraryManagement$.$anonfun$cachedUpdate$12(LibraryManagement.scala:102)
[error]         at sbt.util.Tracked$.$anonfun$lastOutput$1(Tracked.scala:69)
[error]         at sbt.internal.LibraryManagement$.$anonfun$cachedUpdate$20(LibraryManagement.scala:115)
[error]         at scala.util.control.Exception$Catch.apply(Exception.scala:228)
[error]         at sbt.internal.LibraryManagement$.$anonfun$cachedUpdate$11(LibraryManagement.scala:115)
[error]         at sbt.internal.LibraryManagement$.$anonfun$cachedUpdate$11$adapted(LibraryManagement.scala:96)
[error]         at sbt.util.Tracked$.$anonfun$inputChanged$1(Tracked.scala:150)
[error]         at sbt.internal.LibraryManagement$.cachedUpdate(LibraryManagement.scala:129)
[error]         at sbt.Classpaths$.$anonfun$updateTask0$5(Defaults.scala:2950)
[error]         at scala.Function1.$anonfun$compose$1(Function1.scala:49)
[error]         at sbt.internal.util.$tilde$greater.$anonfun$$u2219$1(TypeFunctions.scala:62)
[error]         at sbt.std.Transform$$anon$4.work(Transform.scala:67)
[error]         at sbt.Execute.$anonfun$submit$2(Execute.scala:281)
[error]         at sbt.internal.util.ErrorHandling$.wideConvert(ErrorHandling.scala:19)
[error]         at sbt.Execute.work(Execute.scala:290)
[error]         at sbt.Execute.$anonfun$submit$1(Execute.scala:281)
[error]         at sbt.ConcurrentRestrictions$$anon$4.$anonfun$submitValid$1(ConcurrentRestrictions.scala:178)
[error]         at sbt.CompletionService$$anon$2.call(CompletionService.scala:37)
[error]         at java.util.concurrent.FutureTask.run(Unknown Source)
[error]         at java.util.concurrent.Executors$RunnableAdapter.call(Unknown Source)
[error]         at java.util.concurrent.FutureTask.run(Unknown Source)
[error]         at java.util.concurrent.ThreadPoolExecutor.runWorker(Unknown Source)
[error]         at java.util.concurrent.ThreadPoolExecutor$Worker.run(Unknown Source)
[error]         at java.lang.Thread.run(Unknown Source)
[error] (update) sbt.librarymanagement.ResolveException: Error downloading Chisel-blocks:amba_2.13:+880734-SNAPSHOT
[error]   Not found
[error]   Not found
[error]   not found: /home/pt/vhirvone/.ivy2/local/Chisel-blocks/amba_2.13/+880734-SNAPSHOT/ivys/ivy.xml
[error]   not found: https://repo1.maven.org/maven2/Chisel-blocks/amba_2.13/+880734-SNAPSHOT/amba_2.13-+880734-SNAPSHOT.pom
[error] Total time: 4 s, completed Jun 1, 2022 12:39:01 PM
```

</details>

**Solution:** This can be solved by running `init_submodules.sh` which builds and publishes all submodules of your working directory. This can be quite slow if your module has many dependencies. Alternatively, you can navigate the to submodule producing the error and run `sbt publishLocal` manually.


### 4.3. Using the hardware module in the Scala/Chisel source code

The contents of the `tutorialhardwaremodule` package can be imported by adding the following import statement:
```scala
import tutorialhardwaremodule._
```

And the `TutorialHardwareModule` module can be instantiated within the `ACoreChip` module for example with the code:
```scala
val tutorial_hw = Module(new TutorialHardwareModule(
  proto=DspComplex(UInt(16.W),UInt(16.W)),
  n=8
))
for (i <- 0 until 8) {
  tutorial_hw.io.A(i).real := 0.U
  tutorial_hw.io.A(i).imag := 0.U
}
```
This code simply adds the submodule to the design and drives its inputs with zeros to suppress errors (i.e. it doesn't do anything useful). However, the design should build successfully with `make`.

### 4.4. Commiting changes

Git tracks changes to files in _commits_ which can be thought of as snapshots in time representing the contents of the files. Git tracks the changes to each individual files separately. To see what changes have been made to the last commit you can use `$ git status`. To add files to a commit's staging area you can use the `$ git add` command. In this case, we have modified `init_submodules.sh`, `build.sbt`, and `src/main/scala/acorechip/acorechip.scala`. To add these to the staging area we invoke `git add` like so:
```scala
$ git add init_submodules.sh build.sbt src/main/scala/acorechip/acorechip.scala
```

Now it's time to create a commit, which saves the newly made changes. It's a good habit to run `git status` before commiting to see that all of the desired files are in the staging area (and that there are no extraneous files). Each commit should have a descriptive message, which helps with identifying the changes it makes to the codebase, e.g.
```shell
$ git commit -m "Add TutorialHardwareModule submodule"
```

You can use `$ git log` to browse previous commits. The newly made commit should show up at the top of the list and it should also list the name of the branch next to the commit hash.

At this point you are ready to push the newly made changes to the remote repository (GitLab server) with `$ git push`. Since the remote is not aware of this new branch simply running `git push` will give the following helpful message:

```shell
$ git push
fatal: The current branch tutorial-hardware has no upstream branch.
To push the current branch and set the remote as upstream, use

    git push --set-upstream origin tutorial-hardware

```

Let's go ahead and follow the suggestion:

```shell
$ git push --set-upstream origin tutorial-hardware
```

This should upload the new branch with the new commits to the remote server. Let's open the [ACoreChip] repository up in the browser to see if this is indeed the case:

![](images/5-repo-main-page.png)

Yes! We can see that there's now a new branch, and GitLab is already suggesting to create a merge request (AKA pull request). You can inspect all existing branches by clicking the branches listing. You can also create a new merge request from the branches list. The web interface for creating a merge request is shown below. You should write a description about changes to be made and possibly tag the developers who the changes might affect.

![](images/6-new-pr.png)

Once the merge request has been submitted, it will appear in the merge requests section of the repository. A pending merge request is shown below:

![](images/7-new-pr-submitted.png)

The merge request view has various utilites for discussing about and viewing the changes made in the merge request. The changes tab allows you to view the individual lines of code affected by the changes. It is even possible to add comments and suggestions to individual lines of code. This is a good place to discuss alternatives and suggest improvements to the new feature before they get merged into master. Most of the time the merge request will need some additional work before it is approved for merging to master. This is a way to ensure that other people have a chance to review the code that will be introduced to the implementation and to spot any bugs before they get introduced to the master branch. After the proposed corrections have been made to the branch to be merged, it can be approved for merging and finally merged to the master branch.

You can take a look at and play with the GitLab merge request example [here](https://bubba.ecdl.hut.fi:81/a-core/a-core_chisel/ACoreChip/-/merge_requests/2). Note that this merge request is marked as a draft and is not actually meant to be merged to master as it doesn't do anything useful.

## 5. Creating data types common to multiple modules

Much of the current signaling (e.g. opcodes) has been implemented with enum types to reduce errors with connecting signals to wrong places. As `ChiselEnum`s are strongly typed a wrong connection will result in a compile error. In contrast, even thought it would be technically legal to connect, e.g. two `UInt` type signals with same widths together, they could be encoding data of different types so connecting them would lead to hard-to-debug bugs if the compiler wouldn't disallow this. Custom data types that need to be accessible for multiple modules are defined in [a_core_common]. After making any changes to `a_core_common` you can run the command `sbt publishLocal` which builds and publishes `a_core_common` to the local scala package repository, making the changes available to modules depending on `a_core_common`.

[a_core_common]: https://gitlab.com/a-core/a-core_chisel/a_core_common
[ACoreChip]: https://gitlab.com/a-core/a-core_chisel/ACoreChip
[A-Core_Chisel]: https://gitlab.com/a-core/a-core_chisel
  
